package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Categories;
import com.realnet.basic.Services.CategoriesService ;


@RequestMapping(value = "/token/Categories")
 @CrossOrigin("*") 
@RestController
public class tokenFree_CategoriesController {
	@Autowired
	private CategoriesService Service;

@Value("${projectPath}")
	private String projectPath;
 


	@PostMapping("/Categories")
		  public Categories Savedata(@RequestBody Categories data) {
		Categories save = Service.Savedata(data)	;

		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Categories/{id}")
	public  Categories update(@RequestBody Categories data,@PathVariable Integer id ) {
		Categories update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Categories/getall/page")
	public Page<Categories> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Categories> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Categories")
	public List<Categories> getdetails() {
		 List<Categories> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Categories")
	public List<Categories> getallwioutsec() {
		 List<Categories> get = Service.getdetails();		
		return get;
}
@GetMapping("/Categories/{id}")
	public  Categories  getdetailsbyId(@PathVariable Integer id ) {
		Categories  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Categories/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}



}